#! /bin/sh
### BEGIN INIT INFO
# Provides:          mauvealert-server
# Required-Start:    $remote_fs $syslog
# Required-Stop:     $remote_fs $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Mauve Alert Server
# Description:       Mauve Alert Server 
### END INIT INFO

# Author: Patrick J Cherry <patrick@bytemark.co.uk>
#

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="Mauve Alert Server"
NAME=mauveserver
DAEMON=/usr/sbin/$NAME
DAEMON_ARGS="/etc/mauvealert/$NAME.conf"
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
RUNASUSER=mauvealert

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
	# Return
	#   0 if daemon has been started
	#   1 if daemon was already running
	#   2 if daemon could not be started
  do_test || return 2

	start-stop-daemon --start --quiet --pidfile $PIDFILE --startas $DAEMON --chuid $RUNASUSER --test > /dev/null \
		|| return 1
	start-stop-daemon --start --quiet --pidfile $PIDFILE --make-pidfile --chuid $RUNASUSER --background --startas $DAEMON -- \
		$DAEMON_ARGS \
		|| return 2
	# Add code here, if necessary, that waits for the process to be ready
	# to handle requests from services started subsequently which depend
	# on this one.  As a last resort, sleep for some time.
	count=0

	while [ $((count = count + 1)) -le 5 ] ; do
		sleep 1
    # This is just a test to see if the daemon is running yet.
		start-stop-daemon --start --quiet --pidfile $PIDFILE --startas $DAEMON --chuid $RUNASUSER --test > /dev/null \
			|| return 0
	done

	return 2
}

#
# Function that stops the daemon/service
#
do_stop()
{
	# Return
	#   0 if daemon has been stopped
	#   1 if daemon was already stopped
	#   2 if daemon could not be stopped
	#   other if a failure occurred
	start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --user $RUNASUSER
	RETVAL="$?"
	[ "$RETVAL" = 2 ] && return 2

	# Wait for children to finish too if this is a daemon that forks
	# and if the daemon is only ever run from this initscript.
	# If the above conditions are not satisfied then add some other code
	# that waits for the process to drop all resources that could be
	# needed by services started subsequently.  A last resort is to
	# sleep for some time.
	start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --pidfile $PIDFILE --user $RUNASUSER
  RETVAL="$?"
	[ "$RETVAL" = 2 ] && return 2

	# Many daemons don't delete their pidfiles when they exit.
	rm -f $PIDFILE
	return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
	#
	# If the daemon can reload its configuration without
	# restarting (for example, when it is sent a SIGHUP),
	# then implement that here.
	#
	start-stop-daemon --stop --signal HUP --quiet --pidfile $PIDFILE --user $RUNASUSER
	return 0
}

#
# Function that sends a SIGUSR1 to reopen logfiles
#
do_reopenlogs() {
	start-stop-daemon --stop --signal USR1 --quiet --pidfile $PIDFILE --user $RUNASUSER
	return 0
}


#
# Test the config file before execution
#
do_test() {
  #
  # Make sure we're root
  #
  [ "$USER" = "root" ] || return 1

  #
  # OK test.
  #
  su $RUNASUSER -s /bin/bash -c "$DAEMON -t $DAEMON_ARGS" 1>/dev/null 2>&1  || return 1
  return 0
}

case "$1" in
	start)
  	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
   	do_start
   	case "$?" in
  		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 || exit 0 ;;
   		2) [ "$VERBOSE" != no ] && log_end_msg 1   || exit 1 ;;
   	esac
    ;;

	stop)
  	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
  	do_stop
  	case "$?" in
  		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 || exit 0 ;;
  		2) [ "$VERBOSE" != no ] && log_end_msg 1   || exit 1 ;;
  	esac
  	;;
	
  status)
	  status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
  	;;

	#
	# If do_reload() is not implemented then leave this commented out
	# and leave 'force-reload' as an alias for 'restart'.
	#
	reload|force-reload)
  	log_daemon_msg "Reloading $DESC" "$NAME"
  	do_reload
  	log_end_msg $?
  	;;

	#
	# This is for use by logrotate, as the post-rotate method.
	#
	reopen-logs)
  	log_daemon_msg "Re-opening logs for $DESC" "$NAME"
  	do_reopenlogs
  	log_end_msg $?
  	;;
  
  #
  # This is to test the configuration
  #
  test|config-test)
    log_daemon_msg "Testing configuration for $DESC" "$NAME"
    do_test
    log_end_msg $?
    ;;

	#
	# If the "reload" option is implemented then remove the
	# 'force-reload' alias
	#
	restart)
  	log_daemon_msg "Restarting $DESC" "$NAME"

    do_test
    if [ "$?" != "0" ] ; then
  		log_end_msg 1 # test failed
    fi

  	do_stop
  	case "$?" in
  		0|1)
    		do_start
    		case "$?" in
  	  		0) log_end_msg 0 ;;
  		  	1) log_end_msg 1 ;; # Old process is still running
    			*) log_end_msg 1 ;; # Failed to start
    		esac
  	  	;;
	    *)
	  		# Failed to stop
    		log_end_msg 1
  		  ;;
	  esac
  	;;

	*)
  	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
  	echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload|test}" >&2
	  exit 3
  	;;
esac